// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/LocationAttributesHeader.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__LOCATION_ATTRIBUTES_HEADER__TRAITS_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__LOCATION_ATTRIBUTES_HEADER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "off_highway_premium_radar_sample_msgs/msg/detail/location_attributes_header__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'start_measurement'
#include "off_highway_premium_radar_sample_msgs/msg/detail/time__traits.hpp"
// Member 'operation_mode'
#include "off_highway_premium_radar_sample_msgs/msg/detail/operation_mode__traits.hpp"

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const LocationAttributesHeader & msg,
  std::ostream & out)
{
  out << "{";
  // member: lgp_version
  {
    out << "lgp_version: ";
    rosidl_generator_traits::value_to_yaml(msg.lgp_version, out);
    out << ", ";
  }

  // member: block_counter
  {
    out << "block_counter: ";
    rosidl_generator_traits::value_to_yaml(msg.block_counter, out);
    out << ", ";
  }

  // member: start_measurement
  {
    out << "start_measurement: ";
    to_flow_style_yaml(msg.start_measurement, out);
    out << ", ";
  }

  // member: operation_mode
  {
    out << "operation_mode: ";
    to_flow_style_yaml(msg.operation_mode, out);
    out << ", ";
  }

  // member: data_measured
  {
    out << "data_measured: ";
    rosidl_generator_traits::value_to_yaml(msg.data_measured, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const LocationAttributesHeader & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: lgp_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lgp_version: ";
    rosidl_generator_traits::value_to_yaml(msg.lgp_version, out);
    out << "\n";
  }

  // member: block_counter
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "block_counter: ";
    rosidl_generator_traits::value_to_yaml(msg.block_counter, out);
    out << "\n";
  }

  // member: start_measurement
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "start_measurement:\n";
    to_block_style_yaml(msg.start_measurement, out, indentation + 2);
  }

  // member: operation_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "operation_mode:\n";
    to_block_style_yaml(msg.operation_mode, out, indentation + 2);
  }

  // member: data_measured
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "data_measured: ";
    rosidl_generator_traits::value_to_yaml(msg.data_measured, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const LocationAttributesHeader & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

namespace rosidl_generator_traits
{

[[deprecated("use off_highway_premium_radar_sample_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader & msg,
  std::ostream & out, size_t indentation = 0)
{
  off_highway_premium_radar_sample_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use off_highway_premium_radar_sample_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader & msg)
{
  return off_highway_premium_radar_sample_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader>()
{
  return "off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader";
}

template<>
inline const char * name<off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader>()
{
  return "off_highway_premium_radar_sample_msgs/msg/LocationAttributesHeader";
}

template<>
struct has_fixed_size<off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader>
  : std::integral_constant<bool, has_fixed_size<off_highway_premium_radar_sample_msgs::msg::OperationMode>::value && has_fixed_size<off_highway_premium_radar_sample_msgs::msg::Time>::value> {};

template<>
struct has_bounded_size<off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader>
  : std::integral_constant<bool, has_bounded_size<off_highway_premium_radar_sample_msgs::msg::OperationMode>::value && has_bounded_size<off_highway_premium_radar_sample_msgs::msg::Time>::value> {};

template<>
struct is_message<off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__LOCATION_ATTRIBUTES_HEADER__TRAITS_HPP_
