// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/MeasurementCycleSyncData.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__MEASUREMENT_CYCLE_SYNC_DATA__STRUCT_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__MEASUREMENT_CYCLE_SYNC_DATA__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'sensor_time_offset'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__MeasurementCycleSyncData __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__MeasurementCycleSyncData __declspec(deprecated)
#endif

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MeasurementCycleSyncData_
{
  using Type = MeasurementCycleSyncData_<ContainerAllocator>;

  explicit MeasurementCycleSyncData_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : sensor_time_offset(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->sync = false;
    }
  }

  explicit MeasurementCycleSyncData_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : sensor_time_offset(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->sync = false;
    }
  }

  // field types and members
  using _sync_type =
    bool;
  _sync_type sync;
  using _sensor_time_offset_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _sensor_time_offset_type sensor_time_offset;

  // setters for named parameter idiom
  Type & set__sync(
    const bool & _arg)
  {
    this->sync = _arg;
    return *this;
  }
  Type & set__sensor_time_offset(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->sensor_time_offset = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    off_highway_premium_radar_sample_msgs::msg::MeasurementCycleSyncData_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_premium_radar_sample_msgs::msg::MeasurementCycleSyncData_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::MeasurementCycleSyncData_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::MeasurementCycleSyncData_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::MeasurementCycleSyncData_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::MeasurementCycleSyncData_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::MeasurementCycleSyncData_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::MeasurementCycleSyncData_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::MeasurementCycleSyncData_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::MeasurementCycleSyncData_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__MeasurementCycleSyncData
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::MeasurementCycleSyncData_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__MeasurementCycleSyncData
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::MeasurementCycleSyncData_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MeasurementCycleSyncData_ & other) const
  {
    if (this->sync != other.sync) {
      return false;
    }
    if (this->sensor_time_offset != other.sensor_time_offset) {
      return false;
    }
    return true;
  }
  bool operator!=(const MeasurementCycleSyncData_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MeasurementCycleSyncData_

// alias to use template instance with default allocator
using MeasurementCycleSyncData =
  off_highway_premium_radar_sample_msgs::msg::MeasurementCycleSyncData_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__MEASUREMENT_CYCLE_SYNC_DATA__STRUCT_HPP_
