// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/SensorEthernetConfigurationInformation.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_ETHERNET_CONFIGURATION_INFORMATION__STRUCT_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_ETHERNET_CONFIGURATION_INFORMATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorEthernetConfigurationInformation __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorEthernetConfigurationInformation __declspec(deprecated)
#endif

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SensorEthernetConfigurationInformation_
{
  using Type = SensorEthernetConfigurationInformation_<ContainerAllocator>;

  explicit SensorEthernetConfigurationInformation_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->sensor_ip_address = "";
      this->destination_ip_address = "";
      this->netmask = "";
      this->vlan = 0;
      this->source_port = 0;
      this->destination_port = 0;
    }
  }

  explicit SensorEthernetConfigurationInformation_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : sensor_ip_address(_alloc),
    destination_ip_address(_alloc),
    netmask(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->sensor_ip_address = "";
      this->destination_ip_address = "";
      this->netmask = "";
      this->vlan = 0;
      this->source_port = 0;
      this->destination_port = 0;
    }
  }

  // field types and members
  using _sensor_ip_address_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _sensor_ip_address_type sensor_ip_address;
  using _destination_ip_address_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _destination_ip_address_type destination_ip_address;
  using _netmask_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _netmask_type netmask;
  using _vlan_type =
    uint16_t;
  _vlan_type vlan;
  using _source_port_type =
    uint16_t;
  _source_port_type source_port;
  using _destination_port_type =
    uint16_t;
  _destination_port_type destination_port;

  // setters for named parameter idiom
  Type & set__sensor_ip_address(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->sensor_ip_address = _arg;
    return *this;
  }
  Type & set__destination_ip_address(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->destination_ip_address = _arg;
    return *this;
  }
  Type & set__netmask(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->netmask = _arg;
    return *this;
  }
  Type & set__vlan(
    const uint16_t & _arg)
  {
    this->vlan = _arg;
    return *this;
  }
  Type & set__source_port(
    const uint16_t & _arg)
  {
    this->source_port = _arg;
    return *this;
  }
  Type & set__destination_port(
    const uint16_t & _arg)
  {
    this->destination_port = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorEthernetConfigurationInformation
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorEthernetConfigurationInformation
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SensorEthernetConfigurationInformation_ & other) const
  {
    if (this->sensor_ip_address != other.sensor_ip_address) {
      return false;
    }
    if (this->destination_ip_address != other.destination_ip_address) {
      return false;
    }
    if (this->netmask != other.netmask) {
      return false;
    }
    if (this->vlan != other.vlan) {
      return false;
    }
    if (this->source_port != other.source_port) {
      return false;
    }
    if (this->destination_port != other.destination_port) {
      return false;
    }
    return true;
  }
  bool operator!=(const SensorEthernetConfigurationInformation_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SensorEthernetConfigurationInformation_

// alias to use template instance with default allocator
using SensorEthernetConfigurationInformation =
  off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_ETHERNET_CONFIGURATION_INFORMATION__STRUCT_HPP_
