// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/DoIpInformation.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__DO_IP_INFORMATION__TRAITS_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__DO_IP_INFORMATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "off_highway_premium_radar_sample_msgs/msg/detail/do_ip_information__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const DoIpInformation & msg,
  std::ostream & out)
{
  out << "{";
  // member: physical_address
  {
    out << "physical_address: ";
    rosidl_generator_traits::value_to_yaml(msg.physical_address, out);
    out << ", ";
  }

  // member: functional_address
  {
    out << "functional_address: ";
    rosidl_generator_traits::value_to_yaml(msg.functional_address, out);
    out << ", ";
  }

  // member: target_address
  {
    out << "target_address: ";
    rosidl_generator_traits::value_to_yaml(msg.target_address, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DoIpInformation & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: physical_address
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "physical_address: ";
    rosidl_generator_traits::value_to_yaml(msg.physical_address, out);
    out << "\n";
  }

  // member: functional_address
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "functional_address: ";
    rosidl_generator_traits::value_to_yaml(msg.functional_address, out);
    out << "\n";
  }

  // member: target_address
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "target_address: ";
    rosidl_generator_traits::value_to_yaml(msg.target_address, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DoIpInformation & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

namespace rosidl_generator_traits
{

[[deprecated("use off_highway_premium_radar_sample_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const off_highway_premium_radar_sample_msgs::msg::DoIpInformation & msg,
  std::ostream & out, size_t indentation = 0)
{
  off_highway_premium_radar_sample_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use off_highway_premium_radar_sample_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const off_highway_premium_radar_sample_msgs::msg::DoIpInformation & msg)
{
  return off_highway_premium_radar_sample_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<off_highway_premium_radar_sample_msgs::msg::DoIpInformation>()
{
  return "off_highway_premium_radar_sample_msgs::msg::DoIpInformation";
}

template<>
inline const char * name<off_highway_premium_radar_sample_msgs::msg::DoIpInformation>()
{
  return "off_highway_premium_radar_sample_msgs/msg/DoIpInformation";
}

template<>
struct has_fixed_size<off_highway_premium_radar_sample_msgs::msg::DoIpInformation>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<off_highway_premium_radar_sample_msgs::msg::DoIpInformation>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<off_highway_premium_radar_sample_msgs::msg::DoIpInformation>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__DO_IP_INFORMATION__TRAITS_HPP_
