// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from off_highway_premium_radar_sample_msgs:msg/EgoVehicleData.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__EGO_VEHICLE_DATA__STRUCT_H_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__EGO_VEHICLE_DATA__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'velocity'
#include "geometry_msgs/msg/detail/twist_with_covariance__struct.h"
// Member 'acceleration'
#include "geometry_msgs/msg/detail/accel__struct.h"

/// Struct defined in msg/EgoVehicleData in the package off_highway_premium_radar_sample_msgs.
/**
  * Forward speed, forward speed variance, forward acceleration and yaw rate required
  * Comments provide naming from Technical Customer Information
 */
typedef struct off_highway_premium_radar_sample_msgs__msg__EgoVehicleData
{
  /// FeedBack_VehSpd & FeedBack_VehSpdStdDev & FeedBack_RelYawRate
  /// EgoData_VehSpd & EgoData_VehSpdStdDev & EgoData_RelYawRate
  geometry_msgs__msg__TwistWithCovariance velocity;
  /// FeedBack_LogAcc
  /// EgoData_LogAcc
  geometry_msgs__msg__Accel acceleration;
} off_highway_premium_radar_sample_msgs__msg__EgoVehicleData;

// Struct for a sequence of off_highway_premium_radar_sample_msgs__msg__EgoVehicleData.
typedef struct off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__Sequence
{
  off_highway_premium_radar_sample_msgs__msg__EgoVehicleData * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__EGO_VEHICLE_DATA__STRUCT_H_
