// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/LocationAttributesHeader.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__LOCATION_ATTRIBUTES_HEADER__STRUCT_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__LOCATION_ATTRIBUTES_HEADER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'start_measurement'
#include "off_highway_premium_radar_sample_msgs/msg/detail/time__struct.hpp"
// Member 'operation_mode'
#include "off_highway_premium_radar_sample_msgs/msg/detail/operation_mode__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader __declspec(deprecated)
#endif

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LocationAttributesHeader_
{
  using Type = LocationAttributesHeader_<ContainerAllocator>;

  explicit LocationAttributesHeader_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : start_measurement(_init),
    operation_mode(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->lgp_version = 0ul;
      this->block_counter = 0;
      this->data_measured = false;
    }
  }

  explicit LocationAttributesHeader_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : start_measurement(_alloc, _init),
    operation_mode(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->lgp_version = 0ul;
      this->block_counter = 0;
      this->data_measured = false;
    }
  }

  // field types and members
  using _lgp_version_type =
    uint32_t;
  _lgp_version_type lgp_version;
  using _block_counter_type =
    uint8_t;
  _block_counter_type block_counter;
  using _start_measurement_type =
    off_highway_premium_radar_sample_msgs::msg::Time_<ContainerAllocator>;
  _start_measurement_type start_measurement;
  using _operation_mode_type =
    off_highway_premium_radar_sample_msgs::msg::OperationMode_<ContainerAllocator>;
  _operation_mode_type operation_mode;
  using _data_measured_type =
    bool;
  _data_measured_type data_measured;

  // setters for named parameter idiom
  Type & set__lgp_version(
    const uint32_t & _arg)
  {
    this->lgp_version = _arg;
    return *this;
  }
  Type & set__block_counter(
    const uint8_t & _arg)
  {
    this->block_counter = _arg;
    return *this;
  }
  Type & set__start_measurement(
    const off_highway_premium_radar_sample_msgs::msg::Time_<ContainerAllocator> & _arg)
  {
    this->start_measurement = _arg;
    return *this;
  }
  Type & set__operation_mode(
    const off_highway_premium_radar_sample_msgs::msg::OperationMode_<ContainerAllocator> & _arg)
  {
    this->operation_mode = _arg;
    return *this;
  }
  Type & set__data_measured(
    const bool & _arg)
  {
    this->data_measured = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__LocationAttributesHeader
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LocationAttributesHeader_ & other) const
  {
    if (this->lgp_version != other.lgp_version) {
      return false;
    }
    if (this->block_counter != other.block_counter) {
      return false;
    }
    if (this->start_measurement != other.start_measurement) {
      return false;
    }
    if (this->operation_mode != other.operation_mode) {
      return false;
    }
    if (this->data_measured != other.data_measured) {
      return false;
    }
    return true;
  }
  bool operator!=(const LocationAttributesHeader_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LocationAttributesHeader_

// alias to use template instance with default allocator
using LocationAttributesHeader =
  off_highway_premium_radar_sample_msgs::msg::LocationAttributesHeader_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__LOCATION_ATTRIBUTES_HEADER__STRUCT_HPP_
