// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/SensorBroadcastData.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_BROADCAST_DATA__STRUCT_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_BROADCAST_DATA__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'sensor_ethernet_configuration_information'
#include "off_highway_premium_radar_sample_msgs/msg/detail/sensor_ethernet_configuration_information__struct.hpp"
// Member 'diagnostics_ethernet_configuration_information'
#include "off_highway_premium_radar_sample_msgs/msg/detail/diagnostics_ethernet_configuration_information__struct.hpp"
// Member 'doip_information'
#include "off_highway_premium_radar_sample_msgs/msg/detail/do_ip_information__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorBroadcastData __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorBroadcastData __declspec(deprecated)
#endif

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SensorBroadcastData_
{
  using Type = SensorBroadcastData_<ContainerAllocator>;

  explicit SensorBroadcastData_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : sensor_ethernet_configuration_information(_init),
    diagnostics_ethernet_configuration_information(_init),
    doip_information(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->customer_version = 0ul;
      this->sensor_mac_address = 0ull;
    }
  }

  explicit SensorBroadcastData_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : sensor_ethernet_configuration_information(_alloc, _init),
    diagnostics_ethernet_configuration_information(_alloc, _init),
    doip_information(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->customer_version = 0ul;
      this->sensor_mac_address = 0ull;
    }
  }

  // field types and members
  using _customer_version_type =
    uint32_t;
  _customer_version_type customer_version;
  using _sensor_ethernet_configuration_information_type =
    off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation_<ContainerAllocator>;
  _sensor_ethernet_configuration_information_type sensor_ethernet_configuration_information;
  using _diagnostics_ethernet_configuration_information_type =
    off_highway_premium_radar_sample_msgs::msg::DiagnosticsEthernetConfigurationInformation_<ContainerAllocator>;
  _diagnostics_ethernet_configuration_information_type diagnostics_ethernet_configuration_information;
  using _sensor_mac_address_type =
    uint64_t;
  _sensor_mac_address_type sensor_mac_address;
  using _doip_information_type =
    off_highway_premium_radar_sample_msgs::msg::DoIpInformation_<ContainerAllocator>;
  _doip_information_type doip_information;

  // setters for named parameter idiom
  Type & set__customer_version(
    const uint32_t & _arg)
  {
    this->customer_version = _arg;
    return *this;
  }
  Type & set__sensor_ethernet_configuration_information(
    const off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation_<ContainerAllocator> & _arg)
  {
    this->sensor_ethernet_configuration_information = _arg;
    return *this;
  }
  Type & set__diagnostics_ethernet_configuration_information(
    const off_highway_premium_radar_sample_msgs::msg::DiagnosticsEthernetConfigurationInformation_<ContainerAllocator> & _arg)
  {
    this->diagnostics_ethernet_configuration_information = _arg;
    return *this;
  }
  Type & set__sensor_mac_address(
    const uint64_t & _arg)
  {
    this->sensor_mac_address = _arg;
    return *this;
  }
  Type & set__doip_information(
    const off_highway_premium_radar_sample_msgs::msg::DoIpInformation_<ContainerAllocator> & _arg)
  {
    this->doip_information = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    off_highway_premium_radar_sample_msgs::msg::SensorBroadcastData_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_premium_radar_sample_msgs::msg::SensorBroadcastData_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorBroadcastData_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorBroadcastData_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::SensorBroadcastData_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::SensorBroadcastData_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::SensorBroadcastData_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::SensorBroadcastData_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::SensorBroadcastData_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::SensorBroadcastData_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorBroadcastData
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorBroadcastData_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorBroadcastData
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorBroadcastData_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SensorBroadcastData_ & other) const
  {
    if (this->customer_version != other.customer_version) {
      return false;
    }
    if (this->sensor_ethernet_configuration_information != other.sensor_ethernet_configuration_information) {
      return false;
    }
    if (this->diagnostics_ethernet_configuration_information != other.diagnostics_ethernet_configuration_information) {
      return false;
    }
    if (this->sensor_mac_address != other.sensor_mac_address) {
      return false;
    }
    if (this->doip_information != other.doip_information) {
      return false;
    }
    return true;
  }
  bool operator!=(const SensorBroadcastData_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SensorBroadcastData_

// alias to use template instance with default allocator
using SensorBroadcastData =
  off_highway_premium_radar_sample_msgs::msg::SensorBroadcastData_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_BROADCAST_DATA__STRUCT_HPP_
