// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/SensorEthernetConfigurationInformation.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_ETHERNET_CONFIGURATION_INFORMATION__TRAITS_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_ETHERNET_CONFIGURATION_INFORMATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "off_highway_premium_radar_sample_msgs/msg/detail/sensor_ethernet_configuration_information__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SensorEthernetConfigurationInformation & msg,
  std::ostream & out)
{
  out << "{";
  // member: sensor_ip_address
  {
    out << "sensor_ip_address: ";
    rosidl_generator_traits::value_to_yaml(msg.sensor_ip_address, out);
    out << ", ";
  }

  // member: destination_ip_address
  {
    out << "destination_ip_address: ";
    rosidl_generator_traits::value_to_yaml(msg.destination_ip_address, out);
    out << ", ";
  }

  // member: netmask
  {
    out << "netmask: ";
    rosidl_generator_traits::value_to_yaml(msg.netmask, out);
    out << ", ";
  }

  // member: vlan
  {
    out << "vlan: ";
    rosidl_generator_traits::value_to_yaml(msg.vlan, out);
    out << ", ";
  }

  // member: source_port
  {
    out << "source_port: ";
    rosidl_generator_traits::value_to_yaml(msg.source_port, out);
    out << ", ";
  }

  // member: destination_port
  {
    out << "destination_port: ";
    rosidl_generator_traits::value_to_yaml(msg.destination_port, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SensorEthernetConfigurationInformation & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: sensor_ip_address
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sensor_ip_address: ";
    rosidl_generator_traits::value_to_yaml(msg.sensor_ip_address, out);
    out << "\n";
  }

  // member: destination_ip_address
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "destination_ip_address: ";
    rosidl_generator_traits::value_to_yaml(msg.destination_ip_address, out);
    out << "\n";
  }

  // member: netmask
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "netmask: ";
    rosidl_generator_traits::value_to_yaml(msg.netmask, out);
    out << "\n";
  }

  // member: vlan
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vlan: ";
    rosidl_generator_traits::value_to_yaml(msg.vlan, out);
    out << "\n";
  }

  // member: source_port
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "source_port: ";
    rosidl_generator_traits::value_to_yaml(msg.source_port, out);
    out << "\n";
  }

  // member: destination_port
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "destination_port: ";
    rosidl_generator_traits::value_to_yaml(msg.destination_port, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SensorEthernetConfigurationInformation & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

namespace rosidl_generator_traits
{

[[deprecated("use off_highway_premium_radar_sample_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation & msg,
  std::ostream & out, size_t indentation = 0)
{
  off_highway_premium_radar_sample_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use off_highway_premium_radar_sample_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation & msg)
{
  return off_highway_premium_radar_sample_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation>()
{
  return "off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation";
}

template<>
inline const char * name<off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation>()
{
  return "off_highway_premium_radar_sample_msgs/msg/SensorEthernetConfigurationInformation";
}

template<>
struct has_fixed_size<off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<off_highway_premium_radar_sample_msgs::msg::SensorEthernetConfigurationInformation>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_ETHERNET_CONFIGURATION_INFORMATION__TRAITS_HPP_
