// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from off_highway_premium_radar_sample_msgs:msg/SensorFeedback.idl
// generated code does not contain a copyright notice
#include "off_highway_premium_radar_sample_msgs/msg/detail/sensor_feedback__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `vehicle_time`
#include "off_highway_premium_radar_sample_msgs/msg/detail/time__functions.h"
// Member `measurement_cycle_sync_data`
#include "off_highway_premium_radar_sample_msgs/msg/detail/measurement_cycle_sync_data__functions.h"
// Member `ego_vehicle_data`
#include "off_highway_premium_radar_sample_msgs/msg/detail/ego_vehicle_data__functions.h"

bool
off_highway_premium_radar_sample_msgs__msg__SensorFeedback__init(off_highway_premium_radar_sample_msgs__msg__SensorFeedback * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    off_highway_premium_radar_sample_msgs__msg__SensorFeedback__fini(msg);
    return false;
  }
  // lgp_version
  // vehicle_time
  if (!off_highway_premium_radar_sample_msgs__msg__Time__init(&msg->vehicle_time)) {
    off_highway_premium_radar_sample_msgs__msg__SensorFeedback__fini(msg);
    return false;
  }
  // measurement_cycle_sync_data
  if (!off_highway_premium_radar_sample_msgs__msg__MeasurementCycleSyncData__init(&msg->measurement_cycle_sync_data)) {
    off_highway_premium_radar_sample_msgs__msg__SensorFeedback__fini(msg);
    return false;
  }
  // time_sync_status
  // ego_vehicle_data
  if (!off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__init(&msg->ego_vehicle_data)) {
    off_highway_premium_radar_sample_msgs__msg__SensorFeedback__fini(msg);
    return false;
  }
  return true;
}

void
off_highway_premium_radar_sample_msgs__msg__SensorFeedback__fini(off_highway_premium_radar_sample_msgs__msg__SensorFeedback * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // lgp_version
  // vehicle_time
  off_highway_premium_radar_sample_msgs__msg__Time__fini(&msg->vehicle_time);
  // measurement_cycle_sync_data
  off_highway_premium_radar_sample_msgs__msg__MeasurementCycleSyncData__fini(&msg->measurement_cycle_sync_data);
  // time_sync_status
  // ego_vehicle_data
  off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__fini(&msg->ego_vehicle_data);
}

bool
off_highway_premium_radar_sample_msgs__msg__SensorFeedback__are_equal(const off_highway_premium_radar_sample_msgs__msg__SensorFeedback * lhs, const off_highway_premium_radar_sample_msgs__msg__SensorFeedback * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // lgp_version
  if (lhs->lgp_version != rhs->lgp_version) {
    return false;
  }
  // vehicle_time
  if (!off_highway_premium_radar_sample_msgs__msg__Time__are_equal(
      &(lhs->vehicle_time), &(rhs->vehicle_time)))
  {
    return false;
  }
  // measurement_cycle_sync_data
  if (!off_highway_premium_radar_sample_msgs__msg__MeasurementCycleSyncData__are_equal(
      &(lhs->measurement_cycle_sync_data), &(rhs->measurement_cycle_sync_data)))
  {
    return false;
  }
  // time_sync_status
  if (lhs->time_sync_status != rhs->time_sync_status) {
    return false;
  }
  // ego_vehicle_data
  if (!off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__are_equal(
      &(lhs->ego_vehicle_data), &(rhs->ego_vehicle_data)))
  {
    return false;
  }
  return true;
}

bool
off_highway_premium_radar_sample_msgs__msg__SensorFeedback__copy(
  const off_highway_premium_radar_sample_msgs__msg__SensorFeedback * input,
  off_highway_premium_radar_sample_msgs__msg__SensorFeedback * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // lgp_version
  output->lgp_version = input->lgp_version;
  // vehicle_time
  if (!off_highway_premium_radar_sample_msgs__msg__Time__copy(
      &(input->vehicle_time), &(output->vehicle_time)))
  {
    return false;
  }
  // measurement_cycle_sync_data
  if (!off_highway_premium_radar_sample_msgs__msg__MeasurementCycleSyncData__copy(
      &(input->measurement_cycle_sync_data), &(output->measurement_cycle_sync_data)))
  {
    return false;
  }
  // time_sync_status
  output->time_sync_status = input->time_sync_status;
  // ego_vehicle_data
  if (!off_highway_premium_radar_sample_msgs__msg__EgoVehicleData__copy(
      &(input->ego_vehicle_data), &(output->ego_vehicle_data)))
  {
    return false;
  }
  return true;
}

off_highway_premium_radar_sample_msgs__msg__SensorFeedback *
off_highway_premium_radar_sample_msgs__msg__SensorFeedback__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_premium_radar_sample_msgs__msg__SensorFeedback * msg = (off_highway_premium_radar_sample_msgs__msg__SensorFeedback *)allocator.allocate(sizeof(off_highway_premium_radar_sample_msgs__msg__SensorFeedback), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(off_highway_premium_radar_sample_msgs__msg__SensorFeedback));
  bool success = off_highway_premium_radar_sample_msgs__msg__SensorFeedback__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
off_highway_premium_radar_sample_msgs__msg__SensorFeedback__destroy(off_highway_premium_radar_sample_msgs__msg__SensorFeedback * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    off_highway_premium_radar_sample_msgs__msg__SensorFeedback__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
off_highway_premium_radar_sample_msgs__msg__SensorFeedback__Sequence__init(off_highway_premium_radar_sample_msgs__msg__SensorFeedback__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_premium_radar_sample_msgs__msg__SensorFeedback * data = NULL;

  if (size) {
    data = (off_highway_premium_radar_sample_msgs__msg__SensorFeedback *)allocator.zero_allocate(size, sizeof(off_highway_premium_radar_sample_msgs__msg__SensorFeedback), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = off_highway_premium_radar_sample_msgs__msg__SensorFeedback__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        off_highway_premium_radar_sample_msgs__msg__SensorFeedback__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
off_highway_premium_radar_sample_msgs__msg__SensorFeedback__Sequence__fini(off_highway_premium_radar_sample_msgs__msg__SensorFeedback__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      off_highway_premium_radar_sample_msgs__msg__SensorFeedback__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

off_highway_premium_radar_sample_msgs__msg__SensorFeedback__Sequence *
off_highway_premium_radar_sample_msgs__msg__SensorFeedback__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_premium_radar_sample_msgs__msg__SensorFeedback__Sequence * array = (off_highway_premium_radar_sample_msgs__msg__SensorFeedback__Sequence *)allocator.allocate(sizeof(off_highway_premium_radar_sample_msgs__msg__SensorFeedback__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = off_highway_premium_radar_sample_msgs__msg__SensorFeedback__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
off_highway_premium_radar_sample_msgs__msg__SensorFeedback__Sequence__destroy(off_highway_premium_radar_sample_msgs__msg__SensorFeedback__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    off_highway_premium_radar_sample_msgs__msg__SensorFeedback__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
off_highway_premium_radar_sample_msgs__msg__SensorFeedback__Sequence__are_equal(const off_highway_premium_radar_sample_msgs__msg__SensorFeedback__Sequence * lhs, const off_highway_premium_radar_sample_msgs__msg__SensorFeedback__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!off_highway_premium_radar_sample_msgs__msg__SensorFeedback__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
off_highway_premium_radar_sample_msgs__msg__SensorFeedback__Sequence__copy(
  const off_highway_premium_radar_sample_msgs__msg__SensorFeedback__Sequence * input,
  off_highway_premium_radar_sample_msgs__msg__SensorFeedback__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(off_highway_premium_radar_sample_msgs__msg__SensorFeedback);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    off_highway_premium_radar_sample_msgs__msg__SensorFeedback * data =
      (off_highway_premium_radar_sample_msgs__msg__SensorFeedback *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!off_highway_premium_radar_sample_msgs__msg__SensorFeedback__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          off_highway_premium_radar_sample_msgs__msg__SensorFeedback__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!off_highway_premium_radar_sample_msgs__msg__SensorFeedback__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
