// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from off_highway_premium_radar_sample_msgs:msg/SensorModulationPerformance.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_MODULATION_PERFORMANCE__STRUCT_H_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_MODULATION_PERFORMANCE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in msg/SensorModulationPerformance in the package off_highway_premium_radar_sample_msgs.
/**
  * Comments provide naming from Technical Customer Information
 */
typedef struct off_highway_premium_radar_sample_msgs__msg__SensorModulationPerformance
{
  /// LocAtr_DmpID
  uint8_t detection_of_measurement_program;
  /// LocAtr_ModID
  uint8_t modulation_id;
  float distance_range_scaling;
  /// LocAtr_SepRadDist
  float separability_distance;
  /// LocAtr_SepRadVelo
  float separability_relative_velocity;
  /// LocAtr_PrecRadDist
  float precision_distance;
  /// LocAtr_PrecRadVelo
  float precision_relative_velocity;
  /// LocAtr_RadDistVeloCovVar
  float covariance_of_distance_and_relative_velocity;
  /// LocAtr_MinRadDist
  float minimum_measurable_distance;
  /// LocAtr_MaxRadDist
  float maximum_measurable_distance;
  /// LocAtr_MinRadVelo
  float minimum_measurable_relative_velocity;
  /// LocAtr_MaxRadVelo
  float maximum_measurable_relative_velocity;
} off_highway_premium_radar_sample_msgs__msg__SensorModulationPerformance;

// Struct for a sequence of off_highway_premium_radar_sample_msgs__msg__SensorModulationPerformance.
typedef struct off_highway_premium_radar_sample_msgs__msg__SensorModulationPerformance__Sequence
{
  off_highway_premium_radar_sample_msgs__msg__SensorModulationPerformance * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} off_highway_premium_radar_sample_msgs__msg__SensorModulationPerformance__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_MODULATION_PERFORMANCE__STRUCT_H_
